;********************************************************************
;
;  Filename:   16F1939_Blink_LED.ASM
;  IDE:        MPLAB 8.92
;********************************************************************
;Unterdrckte Warnungen
;  errorlevel	-205 ;Found directive in column 1. 
;  errorlevel	-302 ;Register in operand not in bank 0.  Ensure
   errorlevel	-303 ;Program word too large.  Truncated to core size.(Don't care..) 
;--------------------------------------------------------------------
;- Config
   #include "p16F1939.inc"
   __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
   __CONFIG _CONFIG2, _WRT_OFF & _VCAPEN_OFF & _PLLEN_ON & _STVREN_ON & _BORV_LO & _LVP_OFF
;--------------------------------------------------------------------
;- Constants
;--------------------------------------------------------------------
   CBLOCK   0x20
   cntLoop        ;Zhler fr Schleifendurchlauf in "Delay"
   cntCalls       ;Zhlt Aufrufe von "Delay"
   ENDC
;------------------------------------------------------------------------------
; RESET VECTOR
;------------------------------------------------------------------------------
   ORG     0x0000             ; processor reset vector
   PAGESEL Init
   GOTO    Init               ; When using debug header, first inst.
                              ; may be passed over by ICD2.  
;------------------------------------------------------------------------------
; INTERRUPT SERVICE ROUTINE
;------------------------------------------------------------------------------
   ORG      0x0004            ; nicht verwendet
   RETFIE   
;----------------------------------------------------------------------- 
;- Entry point
;--------------------------------------------------------------------
Init
;--Initialisierung von PORTA
   clrf     PORTA    ;Init PORTA
   BANKSEL  LATA     ;Data Latch
   clrf     LATA
   BANKSEL  ANSELA   ;Input mode analog/digital I/O's
   CLRF     ANSELA   ;digital I/O  
   BANKSEL  TRISA
   clrf     TRISA    ;Set RA<7:0> as outputs
   BANKSEL  0        ;Bank 0
;--------------------------------------------------------------
Main
; LEDs an PORTA werden im Wechsel aus-/ bzw. eingeschaltet. Dazu werden
; alle Portbits zuerst auf Low-Pegel und danach auf High-Pegel gelegt.
; Die Dauer der Ein- bzw. Ausschaltzeit wird durch das Unterprogramm
; "Delay" und die Anzahl der Schleifendurchlufe zum Aufruf von "Delay"
; festgelegt.
;
Main_LED_Off
   movlw    .20
   movwf    cntCalls    ;Zhler zum Aufruf von Delay mit Startwert belegen
   clrf     PORTA       ;LEDs an PORTA AUS (RA7:0 = LOW)
Main_Loop1
   CALL     Delay       ;Delay (6,16ms) aufrufen
   decfsz   cntCalls,f  ;nach 20 Aufrufen von "Delay" Schleife verlassen 
   GOTO     Main_Loop1  ;LED ist ca. 20 x 6,16ms = 1123,2ms AUS
Main_LED_On
   movlw    .20
   movwf    cntCalls    ;Zhler zum Aufruf von Delay mit Startwert belegen
   MOVLW    0xFF 
   MOVWF    PORTA       ;LEDs an PORTA EIN (RA7:0 = HIGH)
Main_Loop2
   CALL     Delay       ;Delay (6,16ms) aufrufen 
   decfsz   cntCalls,f  ;nach 20 Aufrufen von "Delay" Schleife verlassen    
   GOTO     Main_Loop2  ;LED ist ca. 20 x 6,16ms = 1123,2ms EIN
   GOTO  Main           ;auf ein Neues ... 
;--------------------------------------------------------------------
;- Functions
;--------------------------------------------------------------------
Delay
; Bei fosc = 500kHz wird diese Sub in 770 Arbeitszyklen (einschlielich
; "CALL" abgearbeitet
; Die hierfr erforderliche Zeit betrgt 6.16ms
; Wird die Schleife 20x aufgerufen betrgt die Delaydauer=123,2ms
; Hinzu kommen noch die Arbeitszyklen zum Laden des Zhlers cntCalls
; 20 Aufrufe aus dem Hauptprogramm dauer somit 123,72ms oder 
; 15465 Arbeitszyklen
    MOVLW 0xFF
    MOVWF cntLoop
Delay_Loop
    DECFSZ cntLoop,f
    GOTO Delay_Loop
RETURN
;--------------------------------------------------------------------
   END